
const canvas = document.getElementById("myCanvas");
const ctx = canvas.getContext("2d");

let x,y,i,j,ct,p;
let v;
let u;
let dv;
let av;
let f,f1,f2,f3,f4;
let r,l,m,r1,r2,r3;
let a,b,c,e,a1,a2,a3;
let d = { width: canvas.width, height: canvas.height };

function init() {
	    f=0;f1=1;f2=0;f3=1;f4=2;
		v=0;u=2;
		av=1.8;	
		dv=av;
		r=12;
		r1=12;r3=4;
		r2=6;
		l=240;
		m=3;
		a3=60;
		a1=60;a2=120;//amplitude
		b=420;//ref. place
		c=50;//string place
		e=-1;	
		buffer = createBuffer(d.width, d.height);
        drawToBuffer();
}

function createBuffer(width, height) {
    const offscreenCanvas = document.createElement('canvas');
    offscreenCanvas.width = width;
    offscreenCanvas.height = height;
    return offscreenCanvas;
}

function drawToBuffer() {
	const g = buffer.getContext("2d");
		g.fillStyle = "white";
		g.fillRect(0,20,d.width,d.height);
		g.strokeStyle = "black";
        g.beginPath();
        g.moveTo(0,d.height/2);
        g.lineTo(d.width,d.height/2);
        g.stroke();
		
		g.fillStyle = "black";
		if(f1==0)g.fillText("pulse",10,c);
		if(f1==1)g.fillText("sineWave",10,c);
		//g.fillText("ratio of impedance",200,c);
		g.fillStyle = "black";
		if(f2==0)g.fillText("3:0 (freeEnd)",305,c);
    	if(f2==2)g.fillText("3:3 (impedanceMatching)",305,c);
		if(f2==4)g.fillText("1:infinity (fixedEnd)",305,c);
		g.fillStyle = "black";
		if(f2==1)g.fillText("3:1 (freeEndLike) ",305,c);
		if(f2==3)g.fillText("1:3 (fixedEndLike)",305,c);
		if(f3==1){
		g.fillStyle="black";
        g.fillText("display 1",600,c);
		g.fillStyle="blue";
        g.fillText(660,c,690,c);
		g.fillText("actualWave",695,c);
				}
		if(f3==0){
		g.fillStyle="black";
        g.fillText("display 2",600,c);
		g.strokeStyle="blue";
		g.beginPath();
		g.moveTo(660,c);
        g.lineTo(690,c);
		g.stroke();
        g.fillStyle="blue";
		g.fillText("actualWave",695,c);
		g.strokeStyle="cyan";
		g.beginPath();
		g.moveTo(660,c+10);
        g.lineTo(690,c+10);
		g.stroke();
		g.fillStyle="cyan";
        g.fillText("incidentWave",695,c+10);
		g.strokeStyle="magenta";
		g.beginPath();
		g.moveTo(660,c+20);
        g.lineTo(690,c+20);
		g.stroke();
		g.fillStyle="magenta";
		g.fillText("reflectedWave",695,c+20);
				}
		
        
		if(f4==0){
		    g.fillStyle="red";
			g.fillText("program Running",470,d.height-c+10);
			}	
		if(f4==1){
		    g.fillStyle="red";
            g.fillText("program Stop",470,d.height-c+10);
			}	
		if(f4==2){
		    fillStyle="blue";
			g.fillText("program Reset",470,d.height-c+10);
			}
		
		if(f1==1){       //   sineWave   
		 for (x=Math.floor(v/r1)*r1+r1;x<=b;x=x+r1){  //入射波が来る前の左側媒質の直線
			y=d.height/2;		
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
		if(v<=b){
		for (x=0;x<=v;x=x+r1){
			y=a1*Math.sin((x-v)*Math.PI*2/l)+d.height/2;	//はじめの入射波
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
        }
		if(f3==0||f2==2){//&&f2!=2  
		if(v>b){
		for (x=b;x>=0;x=x-r1){//b,0,- ref r1/2
			y=a1*Math.sin((x-v)*Math.PI*2/l)+d.height/2;////-r1/2
            g.fillStyle = "cyan";			
	    if(f2==2)g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
				}
        }
	    }
		
		
		  if(v>b&&v<=2*(b)){                 //合成されるまでの入射波
			for (x=0;x<=2*(b)-v;x=x+r1){
			y=a1*Math.sin((x-v)*Math.PI*2/l)+d.height/2;///////-r1/2
			g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
        }

		if(f2==1||f2==2||f2==3||f2==4){
        if(v<b){                 //transmission
		  for (x=b+r1;x<=d.width;x=x+r2){//r1
			y=d.height/2;	/////	-r2/2
	
		g.fillStyle = "blue";
		if(f2==2||f2==4)g.fillStyle = "darkGray";
		g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
		
		}
     	}
		
		
		if(v>=b){
		  for (x=b+r1+Math.floor(u*(v-b)/r2)*r2;x<=d.width;x=x+r2){//+r1//rr1r2/2////////////r1?
			y=d.height/2;	/////-r2/2	
	     
		g.fillStyle = "blue";
		if(f2==2||f2==4)
		g.fillStyle = "darkGray";
		g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
		}
     	}
		if(v<=2*d.width){//*2
        for (x=b+r1;x<b+r1+Math.floor(u*(v-b)/r2)*r2;x=x+r2){//=//+r1
			if(f2!=1)
     		y=a2*Math.sin((x-(u*(v-b)+b))*Math.PI*2/(l*u))+(d.height/2);   //// -r2/2          
     		if(f2==1)
     		y=a2*Math.sin((x-(u*(v-b)+b)-r2)*Math.PI*2/(l*u))+(d.height/2);  //// -r2/2         //inte  control
         
		g.fillStyle = "blue";
		if(f2==2||f2==4)
		g.fillStyle = "darkGray";
		g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
		}
        }
			if(v>2*d.width){//*2
        for (x=b+r1;x<d.width;x=x+r2){//2
		    y=a2*Math.sin((x-(u*(v-b)+b))*Math.PI*2/(l*u))+(d.height/2);	//-r2/2
            g.fillStyle = "blue";
		if(f2==2||f2==4)
			g.fillStyle = "darkGray";
		    g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
				}
        }
	}
	    if(f2==0){
			if(v<b){                 //transmission
		   g.strokeStyle="blue";
		   g.beginPath();
		   g.moveTo(b,d.height/2);
           g.lineTo(d.width,d.height/2);
		   g.stroke();   
				
     	}
		if(v>=b){
		y=2*a1*Math.sin((b-v)*Math.PI*2/l)+(d.height/2);
           g.strokeStyle="blue";
		   g.beginPath();
		   g.moveTo(b,y);
           g.lineTo(d.width,y);
		   g.stroke();		
		  	}
	}
	if(f3==0&&f2!=2){//反射波等表示２	かつ 33以外   
	  if(v>=(b)&&v<=2*(b)){                 //refrection
			for (x=b;x>=2*(b)-v;x=x-r1){//b+r1/2
			y=a3*Math.sin((2*(b)-x-v)*Math.PI*2/l)+d.height/2;////-r1/2
		    g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
        }
        if(2*(b)<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
			y=a3*Math.sin((2*(b)-x-v)*Math.PI*2/l)+d.height/2;/////-r1/2
            g.fillStyle = "magenta";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
			}
        }
   }//
    if(f2!=2){
       if(v>=b&&v<=2*(b)){                 //all
			for (x=b;x>=2*(b)-v;x=x-r1){
			y=a3*Math.sin((2*(b)-x-v)*Math.PI*2/l)+d.height/2
				+(a1*Math.sin((x-v)*Math.PI*2/l));/////-r1/2
		    g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
        }
		if(2*(b)<v){                 //all
			for (x=b;x>=0;x=x-r1){
			y=a3*Math.sin((2*(b)-x-v)*Math.PI*2/l)+(d.height/2)
				+(a1*Math.sin((x-v)*Math.PI*2/l));///////-r1/2
		    g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
        }
	}//
	}       //  sineWave end 
	
	
	

  	
		
	if(f1==0){       //   pulse  
		 for (x=Math.floor(v/r1)*r1+r1;x<=b;x=x+r1){       //incidence
			y=(d.height/2);		//frontofthepulse
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
				}
		if(v<=b){
		for (x=0;x<Math.floor((v-l)/r1)*r1;x=x+r1){        //behind the pulse
		y=(d.height/2);		
	        g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();    
			}
		for (x=0;x<=v;x=x+r1){         //pulse
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+(d.height/2);		
	        if(x<=v-l)y=(d.height/2);
			g.fillStyle = "blue";
		    g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
	
        }
		
		
	if(f3==0||f2==2){
		if(v>b){
		for (x=0;x<=b;x=x+r1){
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+(d.height/2);		
	        if(x<=v-l)y=(d.height/2);
			g.fillStyle = "cyan";
		   if(f2==2)
			g.fillStyle = "blue";
			g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		}
        }
	}
		  if(v>b&&v<=2*b){                 //inci
			for (x=0;x<=2*b-v;x=x+r1){
			y=-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2)+(d.height/2);
			if(x<=v-l)y=(d.height/2);
			g.fillStyle = "blue";
			g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
				}
        }

	if(f2==1||f2==2||f2==3||f2==4){
        if(v<b){                 //transmission
		  for (x=Math.floor(b/r1)*r1+r1;x<=d.width;x=x+r2){/////////////////
			y=(d.height/2);		
	      g.fillStyle = "blue";
		if(f2==2||f2==4)
		    g.fillStyle = "darkGray";
			g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
		}
     	}

		if(v>=b){
        
		if(f2!=1){
		  for (x=Math.floor((u*(v-b)+b)/r2)*r2+r1;x<=d.width;x=x+r2){//r1
			y=(d.height/2);
				g.fillStyle = "blue";
		if(f2==2||f2==4)
			g.fillStyle = "darkGray";
			g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();	
	     }
		}
		if(f2==1){
		  for (x=Math.floor((u*(v-b)+b)/r2)*r2+7;x<=d.width;x=x+r2){//r1
			y=(d.height/2);		//7 or r1
				g.fillStyle = "blue";
		if(f2==2||f2==4)
			g.fillStyle = "darkGray";
			g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();	
	     }
		}
		
     	} 
		if(v<=3*d.width){//*2
        for (x=b+r1;x<=Math.floor((u*(v-b)+b)/r2)*r2;x=x+r2){
     	y=-(a2*(1-Math.cos((x-(u*(v-b)+b))*3.1415*2/(l*u)))/2)+(d.height/2);        

		if(x>=b+r1&&x<Math.floor((u*(v-b)+b)/r2)*r2-u*l)
			y=(d.height/2);
         
		g.fillStyle = "blue";
		if(f2==2||f2==4)
			g.fillStyle = "darkGray";
			g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();	
		}
        }
			if(v>3*d.width){//*2
        for (x=b+r1;x<d.width;x=x+r2){
    			y=(d.height/2);
	
		     g.fillStyle = "blue";
		if(f2==2||f2==4)
			g.fillStyle = "darkGray";
			g.beginPath();
		    g.arc(x+r2/2,y,r2/2, 0, Math.PI * 2);
			g.fill();
		}
        }
	}
	if(f2==0){
			if(v<b){                 //transmission
		   g.strokeStyle="blue";
		   g.beginPath();
		   g.moveTo(b,d.height/2);
           g.lineTo(d.width,d.height/2);
		   g.stroke();
			
     	}
		if(v>=b&&v<=b+l){
		y=-(2*a1*(1-Math.cos((b-v)*3.1415*2/l))/2)+(d.height/2);
           g.strokeStyle="blue";
		   g.beginPath();
		   g.moveTo(b,y);
           g.lineTo(d.width,y);
		   g.stroke();		
		
     	}
			if(v>b+l){
		y=-(d.height/2);	
		   g.strokeStyle="blue";
		   g.beginPath();
		   g.moveTo(b,y);
           g.lineTo(d.width,y);
		   g.stroke();
		     	}
	}
	if(f3==0&&f2!=2){//
	    if(v>=b&&v<=2*b+l){     //+l            //refrection
			for (x=b;x>=2*b-v;x=x-r1){       //pulse
			y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(d.height/2);
		        if(x>=2*b-v+l&&x<=b)y=(d.height/2);//behind the pulse
			g.fillStyle = "magenta";
			g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();	
				}
        }
        if(2*b+l<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
		//	y=-(int)(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(int)(d.height/2-r1/2);
		y=(d.height/2);
		    g.fillStyle = "magenta";
			g.beginPath();
		    g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			g.fill();
		    	}
        }
   }
	if(f2!=2){
       if(v>=b&&v<=2*b+l){                 //all
		
            if(2*b-v>v-l){
					for (x=b;x>=2*b-v;x=x-r1){
	         	y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(d.height/2)
				-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2);
				       g.fillStyle = "blue";
			           g.beginPath();
		               g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			           g.fill();
							}
			        }
			if((2*b-v<=v-l)&&(b>v-l)){
			

                    	for (x=b;x>=2*b-v;x=x-r1){
							if(x<=v-l)
	         	y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(d.height/2);
						if(x>v-l)
	         	y=-(d.height/2);//exclusive
				         g.fillStyle = "blue";
			           g.beginPath();
		               g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			           g.fill();
			        }

					for (x=b;x>=v-l;x=x-r1){
				y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(d.height/2)
				-(a1*(1-Math.cos((x-v)*3.1415*2/l))/2);
	         			g.fillStyle = "blue";
			           g.beginPath();
		               g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			           g.fill();	
						
			        }
				}
			if(2*b-v+l<b){
			for (x=b;x>=2*b-v;x=x-r1){       //pulse
			y=-(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(d.height/2);
		        if(x>=2*b-v+l&&x<=b)y=(d.height/2);//behind the pulse
				       g.fillStyle = "blue";
			           g.beginPath();
		               g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			           g.fill();
				}
        }
		}
        if(2*b+l<=v){                 //refrection
			for (x=b;x>=0;x=x-r1){
		//	y=-(int)(a3*(1-Math.cos((2*b-x-v)*3.1415*2/l))/2)+(int)(d.height/2-r1/2);
		y=(d.height/2);
		               g.fillStyle = "blue";
			           g.beginPath();
		               g.arc(x+r1/2,y,r1/2, 0, Math.PI * 2);
			           g.fill();
				}
        }




	}//
    }       //  pulse end 
}
		

function move() {
        dv=f*av;
		v=v+dv;
		ct=ct+f*1;
}

function start() {
    setInterval(function() {
        move();
        drawToBuffer();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        ctx.drawImage(buffer, 0, 0);
    }, 20);
} 

document.getElementById('pulse').addEventListener('click', pulse);
document.getElementById('sin').addEventListener('click', sin);
document.getElementById('r30').addEventListener('click', r30);
document.getElementById('r31').addEventListener('click', r31);
document.getElementById('r33').addEventListener('click', r33);
document.getElementById('r13').addEventListener('click', r13);
document.getElementById('r03').addEventListener('click', r03);
document.getElementById('ds1').addEventListener('click', ds1);
document.getElementById('ds2').addEventListener('click', ds2);
document.getElementById('Run').addEventListener('click', Run);
document.getElementById('Stop').addEventListener('click', Stop);
document.getElementById('Reset').addEventListener('click', Reset);


function pulse() {
       f1=0;
}
function sin() {
        f1=1;
}
function r30() {
        f2=0;r1=12;a1=60;a3=a1;l=240;
}
function r31() {
        f2=1;r1=12;r2=6;u=3;a1=60;a2=90;a3=30;l=240;
}
function r33() {
        f2=2;r1=12;r2=12;a1=60;a2=60;u=1;l=240;
}
function r13() {
        f2=3;r1=6;r2=12;a1=60;a3=-30;a2=30;u=0.3333;l=340;
			  if(f1==0){a1=80;a2=40;a3=-40;l=300;}
}
function r03() {
        f2=4;l=340;r1=6;r2=12;a3=-60;a2=0;u=0.1;
				 if(f1==0){a1=80;a2=0;a3=-80;l=300;}
}
function ds1() {
        f3=1;
}
function ds2() {
        f3=0;
}
function Run() {
        f=1;f4=0;
}
function Stop() {
        f=0;dv=0;f4=1;
}
function Reset() {
        f=0;v=0;dv=0;y=0;f4=2;ct=0;
}

init();
start();




